wayland::server::zwp_tablet_tool_v1_t(3)

NAME
wayland::server::zwp_tablet_tool_v1_t - a physical tablet tool

SYNOPSIS

#include <wayland-server-protocol-unstable.hpp>

Inherits wayland::server::resource_t.

  Public Member Functions

std::function< void(uint32_t, surface_t, int32_t, int32_t)> & on_set_cursor ()
set the tablet tool's surface
std::function< void()> & on_destroy ()
destroy the tool object
void type (zwp_tablet_tool_v1_type const &tool_type, bool post=true)
tool type
void hardware_serial (uint32_t hardware_serial_hi, uint32_t hardware_serial_lo, bool post=true)
unique hardware serial number of the tool
void hardware_id_wacom (uint32_t hardware_id_hi, uint32_t hardware_id_lo, bool post=true)
hardware id notification in Wacom's format
void capability (zwp_tablet_tool_v1_capability const &capability, bool post=true)
tool capability notification
void done (bool post=true)
tool description events sequence complete
void removed (bool post=true)
tool removed
void proximity_in (uint32_t serial, zwp_tablet_v1_t const &tablet, surface_t const &surface, bool post=true)
proximity in event
void proximity_out (bool post=true)
proximity out event
void down (uint32_t serial, bool post=true)
tablet tool is making contact
void up (bool post=true)
tablet tool is no longer making contact
void motion (double x, double y, bool post=true)
motion event
void pressure (uint32_t pressure, bool post=true)
pressure change event
void distance (uint32_t distance, bool post=true)
distance change event
void tilt (int32_t tilt_x, int32_t tilt_y, bool post=true)
tilt change event
void rotation (int32_t degrees, bool post=true)
z-rotation change event
void slider (int32_t position, bool post=true)
Slider position change event.
void wheel (int32_t degrees, int32_t clicks, bool post=true)
Wheel delta event.
void button (uint32_t serial, uint32_t button, zwp_tablet_tool_v1_button_state const &state, bool post=true)
button event
void frame (uint32_t time, bool post=true)
frame event
void post_role (std::string const &msg)
Post error: given wl_surface has another role.
bool proxy_has_object () const
Check whether this wrapper actually wraps an object.
void post_no_memory () const
uint32_t get_id () const
client_t get_client () const
unsigned int get_version () const
std::string get_class ()

  Static Public Attributes

static constexpr std::uint32_t type_since_version = 1
Minimum protocol version required for the type function.
static constexpr std::uint32_t hardware_serial_since_version = 1
Minimum protocol version required for the hardware_serial function.
static constexpr std::uint32_t hardware_id_wacom_since_version = 1
Minimum protocol version required for the hardware_id_wacom function.
static constexpr std::uint32_t capability_since_version = 1
Minimum protocol version required for the capability function.
static constexpr std::uint32_t done_since_version = 1
Minimum protocol version required for the done function.
static constexpr std::uint32_t removed_since_version = 1
Minimum protocol version required for the removed function.
static constexpr std::uint32_t proximity_in_since_version = 1
Minimum protocol version required for the proximity_in function.
static constexpr std::uint32_t proximity_out_since_version = 1
Minimum protocol version required for the proximity_out function.
static constexpr std::uint32_t down_since_version = 1
Minimum protocol version required for the down function.
static constexpr std::uint32_t up_since_version = 1
Minimum protocol version required for the up function.
static constexpr std::uint32_t motion_since_version = 1
Minimum protocol version required for the motion function.
static constexpr std::uint32_t pressure_since_version = 1
Minimum protocol version required for the pressure function.
static constexpr std::uint32_t distance_since_version = 1
Minimum protocol version required for the distance function.
static constexpr std::uint32_t tilt_since_version = 1
Minimum protocol version required for the tilt function.
static constexpr std::uint32_t rotation_since_version = 1
Minimum protocol version required for the rotation function.
static constexpr std::uint32_t slider_since_version = 1
Minimum protocol version required for the slider function.
static constexpr std::uint32_t wheel_since_version = 1
Minimum protocol version required for the wheel function.
static constexpr std::uint32_t button_since_version = 1
Minimum protocol version required for the button function.
static constexpr std::uint32_t frame_since_version = 1
Minimum protocol version required for the frame function.

Detailed Description

a physical tablet tool

An object that represents a physical tool that has been, or is currently in use with a tablet in this seat. Each wp_tablet_tool object stays valid until the client destroys it; the compositor reuses the wp_tablet_tool object to indicate that the object's respective physical tool has come into proximity of a tablet again.

A wp_tablet_tool object's relation to a physical tool depends on the tablet's ability to report serial numbers. If the tablet supports this capability, then the object represents a specific physical tool and can be identified even when used on multiple tablets.

A tablet tool has a number of static characteristics, e.g. tool type, hardware_serial and capabilities. These capabilities are sent in an event sequence after the wp_tablet_seat.tool_added event before any actual events from this tool. This initial event sequence is terminated by a wp_tablet_tool.done event.

Tablet tool events are grouped by wp_tablet_tool.frame events. Any events received before a wp_tablet_tool.frame event should be considered part of the same hardware state change.

Definition at line 4135 of file wayland-server-protocol-unstable.hpp.

Member Function Documentation

  void zwp_tablet_tool_v1_t::button (uint32_t serial, uint32_t button, zwp_tablet_tool_v1_button_state const & state, bool post = true)

button event

Parameters
    serial
    button The button whose state has changed
    state Whether the button was pressed or released

Sent whenever a button on the tool is pressed or released.

If a button is held down when the tool moves in or out of proximity, button events are generated by the compositor. See wp_tablet_tool.proximity_in and wp_tablet_tool.proximity_out for details.

Definition at line 6274 of file wayland-server-protocol-unstable.cpp.

  void zwp_tablet_tool_v1_t::capability (zwp_tablet_tool_v1_capability const & capability, bool post = true)

tool capability notification

Parameters
    capability the capability

This event notifies the client of any capabilities of this tool, beyond the main set of x/y axes and tip up/down detection.

One event is sent for each extra capability available on this tool.

This event is sent in the initial burst of events before the wp_tablet_tool.done event.

Definition at line 6204 of file wayland-server-protocol-unstable.cpp.

  void zwp_tablet_tool_v1_t::distance (uint32_t distance, bool post = true)

distance change event

Parameters
    distance The current distance value

Sent whenever the distance axis on a tool changes. The value of this event is normalized to a value between 0 and 65535.

Note that distance may be nonzero even when a tool is not in logical contact. See the down and up events for more details.

Definition at line 6249 of file wayland-server-protocol-unstable.cpp.

  void zwp_tablet_tool_v1_t::done (bool post = true)

tool description events sequence complete This event signals the end of the initial burst of descriptive events. A client may consider the static description of the tool to be complete and finalize initialization of the tool.

Definition at line 6209 of file wayland-server-protocol-unstable.cpp.

  void zwp_tablet_tool_v1_t::down (uint32_t serial, bool post = true)

tablet tool is making contact

Parameters
    serial

Sent whenever the tablet tool comes in contact with the surface of the tablet.

If the tool is already in contact with the tablet when entering the input region, the client owning said region will receive a wp_tablet.proximity_in event, followed by a wp_tablet.down event and a wp_tablet.frame event.

Note that this event describes logical contact, not physical contact. On some devices, a compositor may not consider a tool in logical contact until a minimum physical pressure threshold is exceeded.

Definition at line 6229 of file wayland-server-protocol-unstable.cpp.

  void zwp_tablet_tool_v1_t::frame (uint32_t time, bool post = true)

frame event

Parameters
    time The time of the event with millisecond granularity

Marks the end of a series of axis and/or button updates from the tablet. The Wayland protocol requires axis updates to be sent sequentially, however all events within a frame should be considered one hardware event.

Definition at line 6279 of file wayland-server-protocol-unstable.cpp.

  std::string wayland::server::resource_t::get_class () [inherited]
Retrieve the interface name (class) of a resource object.

Returns
    Interface name of the resource object.

  client_t wayland::server::resource_t::get_client () const [inherited]
Get the associated client

Returns
    the client that owns the resource.

  uint32_t wayland::server::resource_t::get_id () const [inherited]
Get the internal ID of the resource

Returns
    the internal ID of the resource

  unsigned int wayland::server::resource_t::get_version () const [inherited]
Get interface version

Returns
    Interface version this resource has been constructed with.

  void zwp_tablet_tool_v1_t::hardware_id_wacom (uint32_t hardware_id_hi, uint32_t hardware_id_lo, bool post = true)

hardware id notification in Wacom's format

Parameters
    hardware_id_hi the hardware id, most significant bits
    hardware_id_lo the hardware id, least significant bits

This event notifies the client of a hardware id available on this tool.

The hardware id is a device-specific 64-bit id that provides extra information about the tool in use, beyond the wl_tool.type enumeration. The format of the id is specific to tablets made by Wacom Inc. For example, the hardware id of a Wacom Grip Pen (a stylus) is 0x802.

This event is sent in the initial burst of events before the wp_tablet_tool.done event.

Definition at line 6199 of file wayland-server-protocol-unstable.cpp.

  void zwp_tablet_tool_v1_t::hardware_serial (uint32_t hardware_serial_hi, uint32_t hardware_serial_lo, bool post = true)

unique hardware serial number of the tool

Parameters
    hardware_serial_hi the unique serial number of the tool, most significant bits
    hardware_serial_lo the unique serial number of the tool, least significant bits

If the physical tool can be identified by a unique 64-bit serial number, this event notifies the client of this serial number.

If multiple tablets are available in the same seat and the tool is uniquely identifiable by the serial number, that tool may move between tablets.

Otherwise, if the tool has no serial number and this event is missing, the tool is tied to the tablet it first comes into proximity with. Even if the physical tool is used on multiple tablets, separate wp_tablet_tool objects will be created, one per tablet.

This event is sent in the initial burst of events before the wp_tablet_tool.done event.

Definition at line 6194 of file wayland-server-protocol-unstable.cpp.

  void zwp_tablet_tool_v1_t::motion (double x, double y, bool post = true)

motion event

Parameters
    x surface-local x coordinate
    y surface-local y coordinate

Sent whenever a tablet tool moves.

Definition at line 6239 of file wayland-server-protocol-unstable.cpp.

  std::function< void()> & zwp_tablet_tool_v1_t::on_destroy ()

destroy the tool object This destroys the client's resource for this tool object.

Definition at line 6183 of file wayland-server-protocol-unstable.cpp.

  std::function< void(uint32_t, surface_t, int32_t, int32_t)> & zwp_tablet_tool_v1_t::on_set_cursor ()

set the tablet tool's surface

Parameters
    serial serial of the enter event
    surface
    hotspot_x surface-local x coordinate
    hotspot_y surface-local y coordinate

Sets the surface of the cursor used for this tool on the given tablet. This request only takes effect if the tool is in proximity of one of the requesting client's surfaces or the surface parameter is the current pointer surface. If there was a previous surface set with this request it is replaced. If surface is NULL, the cursor image is hidden.

The parameters hotspot_x and hotspot_y define the position of the pointer surface relative to the pointer location. Its top-left corner is always at (x, y) - (hotspot_x, hotspot_y), where (x, y) are the coordinates of the pointer location, in surface-local coordinates.

On surface.attach requests to the pointer surface, hotspot_x and hotspot_y are decremented by the x and y parameters passed to the request. Attach must be confirmed by wl_surface.commit as usual.

The hotspot can also be updated by passing the currently set pointer surface to this request with new values for hotspot_x and hotspot_y.

The current and pending input regions of the wl_surface are cleared, and wl_surface.set_input_region is ignored until the wl_surface is no longer used as the cursor. When the use as a cursor ends, the current and pending input regions become undefined, and the wl_surface is unmapped.

This request gives the surface the role of a cursor. The role assigned by this request is the same as assigned by wl_pointer.set_cursor meaning the same surface can be used both as a wl_pointer cursor and a wp_tablet cursor. If the surface already has another role, it raises a protocol error. The surface may be used on multiple tablets and across multiple seats.

Definition at line 6177 of file wayland-server-protocol-unstable.cpp.

  void wayland::server::resource_t::post_no_memory () const [inherited]
Post 'not enough memory' error to the client

If the compositor has not enough memory to fulfill a certail request of the client, this function can be called to notify the client of this circumstance.

  void zwp_tablet_tool_v1_t::post_role (std::string const & msg)

Post error: given wl_surface has another role.

Definition at line 6284 of file wayland-server-protocol-unstable.cpp.

  void zwp_tablet_tool_v1_t::pressure (uint32_t pressure, bool post = true)

pressure change event

Parameters
    pressure The current pressure value

Sent whenever the pressure axis on a tool changes. The value of this event is normalized to a value between 0 and 65535.

Note that pressure may be nonzero even when a tool is not in logical contact. See the down and up events for more details.

Definition at line 6244 of file wayland-server-protocol-unstable.cpp.

  void zwp_tablet_tool_v1_t::proximity_in (uint32_t serial, zwp_tablet_v1_t const & tablet, surface_t const & surface, bool post = true)

proximity in event

Parameters
    serial
    tablet The tablet the tool is in proximity of
    surface The current surface the tablet tool is over

Notification that this tool is focused on a certain surface.

This event can be received when the tool has moved from one surface to another, or when the tool has come back into proximity above the surface.

If any button is logically down when the tool comes into proximity, the respective button event is sent after the proximity_in event but within the same frame as the proximity_in event.

Definition at line 6219 of file wayland-server-protocol-unstable.cpp.

  void zwp_tablet_tool_v1_t::proximity_out (bool post = true)

proximity out event Notification that this tool has either left proximity, or is no longer focused on a certain surface.

When the tablet tool leaves proximity of the tablet, button release events are sent for each button that was held down at the time of leaving proximity. These events are sent before the proximity_out event but within the same wp_tablet.frame.

If the tool stays within proximity of the tablet, but the focus changes from one surface to another, a button release event may not be sent until the button is actually released or the tool leaves the proximity of the tablet.

Definition at line 6224 of file wayland-server-protocol-unstable.cpp.

  bool wayland::server::resource_t::proxy_has_object () const [inherited]

Check whether this wrapper actually wraps an object.

Returns
    true if there is an underlying object, false if this wrapper is empty

  void zwp_tablet_tool_v1_t::removed (bool post = true)

tool removed This event is sent when the tool is removed from the system and will send no further events. Should the physical tool come back into proximity later, a new wp_tablet_tool object will be created.

It is compositor-dependent when a tool is removed. A compositor may remove a tool on proximity out, tablet removal or any other reason. A compositor may also keep a tool alive until shutdown.

If the tool is currently in proximity, a proximity_out event will be sent before the removed event. See wp_tablet_tool.proximity_out for the handling of any buttons logically down.

When this event is received, the client must wp_tablet_tool.destroy the object.

Definition at line 6214 of file wayland-server-protocol-unstable.cpp.

  void zwp_tablet_tool_v1_t::rotation (int32_t degrees, bool post = true)

z-rotation change event

Parameters
    degrees The current rotation of the Z axis

Sent whenever the z-rotation axis on the tool changes. The rotation value is in 0.01 of a degree clockwise from the tool's logical neutral position.

Definition at line 6259 of file wayland-server-protocol-unstable.cpp.

  void zwp_tablet_tool_v1_t::slider (int32_t position, bool post = true)

Slider position change event.

Parameters
    position The current position of slider

Sent whenever the slider position on the tool changes. The value is normalized between -65535 and 65535, with 0 as the logical neutral position of the slider.

The slider is available on e.g. the Wacom Airbrush tool.

Definition at line 6264 of file wayland-server-protocol-unstable.cpp.

  void zwp_tablet_tool_v1_t::tilt (int32_t tilt_x, int32_t tilt_y, bool post = true)

tilt change event

Parameters
    tilt_x The current value of the X tilt axis
    tilt_y The current value of the Y tilt axis

Sent whenever one or both of the tilt axes on a tool change. Each tilt value is in 0.01 of a degree, relative to the z-axis of the tablet. The angle is positive when the top of a tool tilts along the positive x or y axis.

Definition at line 6254 of file wayland-server-protocol-unstable.cpp.

  void zwp_tablet_tool_v1_t::type (zwp_tablet_tool_v1_type const & tool_type, bool post = true)

tool type

Parameters
    tool_type the physical tool type

The tool type is the high-level type of the tool and usually decides the interaction expected from this tool.

This event is sent in the initial burst of events before the wp_tablet_tool.done event.

Definition at line 6189 of file wayland-server-protocol-unstable.cpp.

  void zwp_tablet_tool_v1_t::up (bool post = true)

tablet tool is no longer making contact Sent whenever the tablet tool stops making contact with the surface of the tablet, or when the tablet tool moves out of the input region and the compositor grab (if any) is dismissed.

If the tablet tool moves out of the input region while in contact with the surface of the tablet and the compositor does not have an ongoing grab on the surface, the client owning said region will receive a wp_tablet.up event, followed by a wp_tablet.proximity_out event and a wp_tablet.frame event. If the compositor has an ongoing grab on this device, this event sequence is sent whenever the grab is dismissed in the future.

Note that this event describes logical contact, not physical contact. On some devices, a compositor may not consider a tool out of logical contact until physical pressure falls below a specific threshold.

Definition at line 6234 of file wayland-server-protocol-unstable.cpp.

  void zwp_tablet_tool_v1_t::wheel (int32_t degrees, int32_t clicks, bool post = true)

Wheel delta event.

Parameters
    degrees The wheel delta in 0.01 of a degree
    clicks The wheel delta in discrete clicks

Sent whenever the wheel on the tool emits an event. This event contains two values for the same axis change. The degrees value is in 0.01 of a degree in the same orientation as the wl_pointer.vertical_scroll axis. The clicks value is in discrete logical clicks of the mouse wheel. This value may be zero if the movement of the wheel was less than one logical click.

Clients should choose either value and avoid mixing degrees and clicks. The compositor may accumulate values smaller than a logical click and emulate click events when a certain threshold is met. Thus, wl_tablet_tool.wheel events with non-zero clicks values may have different degrees values.

Definition at line 6269 of file wayland-server-protocol-unstable.cpp.

Member Data Documentation

  constexpr std::uint32_t wayland::server::zwp_tablet_tool_v1_t::button_since_version = 1 [static], [constexpr]

Minimum protocol version required for the button function.

Definition at line 4556 of file wayland-server-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::server::zwp_tablet_tool_v1_t::capability_since_version = 1 [static], [constexpr]

Minimum protocol version required for the capability function.

Definition at line 4292 of file wayland-server-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::server::zwp_tablet_tool_v1_t::distance_since_version = 1 [static], [constexpr]

Minimum protocol version required for the distance function.

Definition at line 4467 of file wayland-server-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::server::zwp_tablet_tool_v1_t::done_since_version = 1 [static], [constexpr]

Minimum protocol version required for the done function.

Definition at line 4305 of file wayland-server-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::server::zwp_tablet_tool_v1_t::down_since_version = 1 [static], [constexpr]

Minimum protocol version required for the down function.

Definition at line 4396 of file wayland-server-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::server::zwp_tablet_tool_v1_t::frame_since_version = 1 [static], [constexpr]

Minimum protocol version required for the frame function.

Definition at line 4571 of file wayland-server-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::server::zwp_tablet_tool_v1_t::hardware_id_wacom_since_version = 1 [static], [constexpr]

Minimum protocol version required for the hardware_id_wacom function.

Definition at line 4274 of file wayland-server-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::server::zwp_tablet_tool_v1_t::hardware_serial_since_version = 1 [static], [constexpr]

Minimum protocol version required for the hardware_serial function.

Definition at line 4252 of file wayland-server-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::server::zwp_tablet_tool_v1_t::motion_since_version = 1 [static], [constexpr]

Minimum protocol version required for the motion function.

Definition at line 4435 of file wayland-server-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::server::zwp_tablet_tool_v1_t::pressure_since_version = 1 [static], [constexpr]

Minimum protocol version required for the pressure function.

Definition at line 4451 of file wayland-server-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::server::zwp_tablet_tool_v1_t::proximity_in_since_version = 1 [static], [constexpr]

Minimum protocol version required for the proximity_in function.

Definition at line 4351 of file wayland-server-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::server::zwp_tablet_tool_v1_t::proximity_out_since_version = 1 [static], [constexpr]

Minimum protocol version required for the proximity_out function.

Definition at line 4373 of file wayland-server-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::server::zwp_tablet_tool_v1_t::removed_since_version = 1 [static], [constexpr]

Minimum protocol version required for the removed function.

Definition at line 4329 of file wayland-server-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::server::zwp_tablet_tool_v1_t::rotation_since_version = 1 [static], [constexpr]

Minimum protocol version required for the rotation function.

Definition at line 4497 of file wayland-server-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::server::zwp_tablet_tool_v1_t::slider_since_version = 1 [static], [constexpr]

Minimum protocol version required for the slider function.

Definition at line 4513 of file wayland-server-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::server::zwp_tablet_tool_v1_t::tilt_since_version = 1 [static], [constexpr]

Minimum protocol version required for the tilt function.

Definition at line 4483 of file wayland-server-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::server::zwp_tablet_tool_v1_t::type_since_version = 1 [static], [constexpr]

Minimum protocol version required for the type function.

Definition at line 4225 of file wayland-server-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::server::zwp_tablet_tool_v1_t::up_since_version = 1 [static], [constexpr]

Minimum protocol version required for the up function.

Definition at line 4422 of file wayland-server-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::server::zwp_tablet_tool_v1_t::wheel_since_version = 1 [static], [constexpr]

Minimum protocol version required for the wheel function.

Definition at line 4537 of file wayland-server-protocol-unstable.hpp.

Author

Generated automatically by Doxygen for Wayland++ from the source code.